//modified by Jing Yang after 7/6/2001
#ifndef CLinklist_H
#define CLinklist_H

#include <stdio.h>

class CLinkListNode
{
public:
	void* element;
	CLinkListNode* next;
	CLinkListNode* prev;

public:
	CLinkListNode()
	{
		next = NULL;
		prev = NULL;
	}

	CLinkListNode(void* ele)
	{
		element = ele;
		next = NULL;
		prev = NULL;
	}
	
	~CLinkListNode()
	{
	}
};

class CLinkList
{
protected:
    CLinkListNode *head, *tail;
	int length;

public:
    CLinkList();
	~CLinkList();
	
    int GetLength();

    void AddNodeAtEnd(void* new_ele);
	void AddNodeAtStart(void* new_ele);
	void AddNodeAfter(void* new_ele, CLinkListNode *node);
    
    bool DeleteElement(void* ele);
    bool Delete(int N);
	bool DeleteNode(CLinkListNode* del_node);
	
    CLinkListNode* GetFirst();
    CLinkListNode* GetNext( CLinkListNode* node);
    CLinkListNode* Get( int N );
    void* GetElement(int N);

    void* TransToArray();

    bool RemoveNode(CLinkListNode* del_node);
	void AddNodeAtStart(CLinkListNode* new_node);
};



#endif

