#ifndef CParoordTool_H
#define CParoordTool_H

#include <xmdv/CFlatParcoord.h>
#include <xmdv/Vec2.h>

class CParcoordTool : public CFlatParcoord 
{
private: 
    ARR<Vec2> poly;

public:
	CParcoordTool(CFlatDisplayInformation* hier_info);
    ~CParcoordTool();

protected:
    //set parameters used for drawing, to be rewritten in subclasses;
    void Draw();

    //event handlers
    void InputMouseMotion(int x, int y);
    void InputButtonPress(int button, int x, int y);
    void InputButtonRelease(int button, int x, int y);

};

#endif



