// SimpleValue.cpp: implementation of the SimpleValue class.
//
//////////////////////////////////////////////////////////////////////

#pragma warning(disable:4786)

#include <SAX/InputSource.h>
#include <SAX/XMLReader.h>
//#include <SAX/helpers/FeatureNames.h>
#include <SAX/helpers/DefaultHandler.h>

#include <meta/SimpleValue.h>

//////////////////////////////////////////////////////////////////////

class SimpleValue::SimpleValueHandler : public SAX::DefaultHandler
{
public:
	SimpleValueHandler(SimpleValue *sv) : mSimpleVal(sv) {}
	
	////////////////////////////////////////////////////
	// DefaultHandler
	virtual void startElement(const std::string& namespaceURI, const std::string& localName,
		const std::string& qName, const AttributesT& atts);
	virtual void endElement(const std::string& namespaceURI, const std::string& localName,
		const std::string& qName);
	
	SAX::XMLReader<std::string> mParser;
	
private:
	SimpleValue *mSimpleVal;
	
};

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SimpleValue::SimpleValue()
{

}

SimpleValue::~SimpleValue()
{

}

//void SimpleValue::unmarshal(SAX::XMLReader<std::string> *parser,SAX::ContentHandler *parentHandler)
//{
//	mHandler->mParser = parser;
//	mHandler->mParentHandler = parentHandler;
//	parser->setContentHandler(*mHandler);
//}

//////////////////////////////////////////////////////////////////////////
// SimpleValueHandler

/*virtual*/ 
void SimpleValue::SimpleValueHandler::startElement(const std::string& namespaceURI,
											   const std::string& localName,
											   const std::string& qName,
											   const AttributesT& atts)
{
	if (localName.length()) {
		if (localName == "restriction") {
//			mRestriction = new Restriction;
		}

		if (localName == "minInclusive") {
//			setRestriction(Restriction.minInclusive, atoi(atts.getValue("value").c_str()));
		}
	}
}

/*virtual*/ 
void SimpleValue::SimpleValueHandler::endElement(const std::string& namespaceURI,
											 const std::string& localName,
											 const std::string& qName)
{
	if (localName.length()) {
		if (localName == "simpleType") {
//			mParser->setContentHandler(*mParentHandler);
		}
	}
}
